--
--Tourist paths from Czech republic
--
--and various symbols from beer to pig
--
--Author: Severak
--Licence: MIT to all
--Version: 1.2
--

local function kct_sign_place(pos)
	local meta = minetest.get_meta(pos)
	meta:set_string("formspec", "field[text;;${text}]")
	meta:set_string("infotext", "\"\"")
end

local function kct_sign_receive_field(pos, formname, fields, sender)
	local meta = minetest.get_meta(pos)
	fields.text = fields.text or ""
	print((sender:get_player_name() or "").." wrote \""..fields.text..
			"\" to sign at "..minetest.pos_to_string(pos))
	meta:set_string("text", fields.text)
	meta:set_string("infotext", '"'..fields.text..'"')
end

local function kct_register_color(color)
	minetest.register_node("kct:"..color, {
	description = color.." trail",
	drawtype = "signlike",
	tile_images = {"kct_"..color..".png"},
	inventory_image = "kct_"..color..".png",
	paramtype = "light",
	paramtype2 = "wallmounted",
	selection_box = {type = "wallmounted"},
	groups = {choppy=2,dig_immediate=2,attached_node=1},
	legacy_wallmounted = true,
	walkable = false
	})
	
	minetest.register_craft({
		output = "kct:"..color.." 12",
		recipe = {
			{"default:paper", "default:paper", "default:paper"},
			{"dye:"..color, "dye:"..color, "dye:"..color},
			{"default:paper", "default:paper", "default:paper"}
		}
	})
	
	minetest.register_node("kct:"..color.."_right", {
	description = color.." trail right",
	drawtype = "signlike",
	tile_images = {"kct_"..color.."_right.png"},
	inventory_image = "kct_"..color.."_right.png",
	paramtype = "light",
	paramtype2 = "wallmounted",
	selection_box = {type = "wallmounted"},
	groups = {choppy=2,dig_immediate=2,attached_node=1},
	legacy_wallmounted = true,
	walkable = false
	})
	
	minetest.register_craft({
		output = "kct:"..color.."_right",
		recipe = {
			{"", "", ""},
			{"", "default:paper", "kct:"..color},
			{"", "", ""}
		}
	})

  minetest.register_node("kct:"..color.."_right_sign", {
	description = color.." trail sign right",
	drawtype = "signlike",
	tile_images = {"kct_"..color.."_right_sign.png"},
	inventory_image = "kct_"..color.."_right_sign.png",
	paramtype = "light",
	paramtype2 = "wallmounted",
	selection_box = {type = "wallmounted"},
	metadata_name = "sign",
	groups = {choppy=2,dig_immediate=2,attached_node=1},
	legacy_wallmounted = true,
	walkable = false,
	on_construct = kct_sign_place,
	on_receive_fields = kct_sign_receive_field
	})
	
	minetest.register_craft({
		output = "kct:"..color.."_right_sign",
		recipe = {
			{"", "", ""},
			{"", "default:sign_wall", "kct:"..color},
			{"", "", ""}
		}
	})

	minetest.register_node("kct:"..color.."_left", {
	description = color.." trail letf",
	drawtype = "signlike",
	tile_images = {"kct_"..color.."_left.png"},
	inventory_image = "kct_"..color.."_left.png",
	paramtype = "light",
	paramtype2 = "wallmounted",
	selection_box = {type = "wallmounted"},
	groups = {choppy=2,dig_immediate=2,attached_node=1},
	legacy_wallmounted = true,
	walkable = false
	})
	
	minetest.register_craft({
		output = "kct:"..color.."_left",
		recipe = {
			{"", "", ""},
			{"kct:"..color, "default:paper", ""},
			{"", "", ""}
		}
	})

	minetest.register_node("kct:"..color.."_left_sign", {
	description = color.." trail sign letf",
	drawtype = "signlike",
	tile_images = {"kct_"..color.."_left_sign.png"},
	inventory_image = "kct_"..color.."_left_sign.png",
	paramtype = "light",
	paramtype2 = "wallmounted",
	selection_box = {type = "wallmounted"},
	groups = {choppy=2,dig_immediate=2,attached_node=1},
	legacy_wallmounted = true,
	walkable = false,
	on_construct = kct_sign_place,
	on_receive_fields = kct_sign_receive_field
	})
	
	minetest.register_craft({
		output = "kct:"..color.."_left_sign",
		recipe = {
			{"", "", ""},
			{"kct:"..color, "default:sign_wall", ""},
			{"", "", ""}
		}
	})

end

kct_register_color("red")
kct_register_color("yellow")
kct_register_color("green")

minetest.register_node("kct:bus", {
	description = "Bus symbol",
	drawtype = "signlike",
	tile_images = {"kct_bus.png"},
	inventory_image = "kct_bus.png",
	paramtype = "light",
	paramtype2 = "wallmounted",
	selection_box = {type = "wallmounted"},
	groups = {choppy=2,dig_immediate=2,attached_node=1},
	legacy_wallmounted = true,
	walkable = false
})

minetest.register_node("kct:beer", {
	description = "Beer symbol",
	drawtype = "signlike",
	tile_images = {"kct_beer.png"},
	inventory_image = "kct_beer.png",
	paramtype = "light",
	paramtype2 = "wallmounted",
	selection_box = {type = "wallmounted"},
	groups = {choppy=2,dig_immediate=2,attached_node=1},
	legacy_wallmounted = true,
	walkable = false
})

local chest_formspec = 
	"size[8,9]"..
	"list[current_name;main;0,0;8,4;]"..
	"list[current_player;main;0,5;8,4;]"

minetest.register_node("kct:postbox", {
	description = "Postbox",
	tile_images = {"kct_orange.png", "kct_orange.png", "kct_orange.png", "kct_orange.png", "kct_orange.png", "kct_post.png"},
	paramtype2 = "facedir",
	groups = {choppy=2,oddly_breakable_by_hand=2},
	legacy_facedir_simple = true,
	on_construct = function(pos)
		local meta = minetest.get_meta(pos)
		meta:set_string("formspec", chest_formspec)
		meta:set_string("infotext", "Postbox")
		local inv = meta:get_inventory()
		inv:set_size("main", 8*4)
	end,
	can_dig = function(pos,player)
		local meta = minetest.get_meta(pos);
		local inv = meta:get_inventory()
		return inv:is_empty("main")
	end,
})

minetest.register_node("kct:city", {
	description = "City name",
	drawtype = "signlike",
	tile_images = {"kct_city.png"},
	inventory_image = "kct_city.png",
	paramtype = "light",
	paramtype2 = "wallmounted",
	selection_box = {type = "wallmounted"},
	groups = {choppy=2,dig_immediate=2,attached_node=1},
	legacy_wallmounted = true,
	walkable = false,
	on_construct = kct_sign_place,
	on_receive_fields = kct_sign_receive_field
})

minetest.register_node("kct:city_end", {
	description = "City name at exit",
	drawtype = "signlike",
	tile_images = {"kct_city_end.png"},
	inventory_image = "kct_city_end.png",
	paramtype = "light",
	paramtype2 = "wallmounted",
	selection_box = {type = "wallmounted"},
	groups = {choppy=2,dig_immediate=2,attached_node=1},
	legacy_wallmounted = true,
	walkable = false,
	on_construct = kct_sign_place,
	on_receive_fields = kct_sign_receive_field
})

minetest.register_node("kct:street", {
	description = "Street name",
	drawtype = "signlike",
	tile_images = {"kct_street.png"},
	inventory_image = "kct_street.png",
	paramtype = "light",
	paramtype2 = "wallmounted",
	selection_box = {type = "wallmounted"},
	groups = {choppy=2,dig_immediate=2,attached_node=1},
	legacy_wallmounted = true,
	walkable = false,
	on_construct = kct_sign_place,
	on_receive_fields = kct_sign_receive_field
})

minetest.register_node("kct:crossing", {
	description = "Railway crossing",
	drawtype = "signlike",
	tile_images = {"kct_crossing.png"},
	inventory_image = "kct_crossing.png",
	paramtype = "light",
	paramtype2 = "wallmounted",
	selection_box = {type = "wallmounted"},
	walkable = false
})

minetest.register_node("kct:pig", {
	description = "Pig symbol",
	drawtype = "signlike",
	tile_images = {"kct_pig.png"},
	inventory_image = "kct_pig.png",
	paramtype = "light",
	paramtype2 = "wallmounted",
	selection_box = {type = "wallmounted"},
	groups = {choppy=2,dig_immediate=2,attached_node=1},
	legacy_wallmounted = true,
	walkable = false,
	on_construct = kct_sign_place,
	on_receive_fields = kct_sign_receive_field
})